﻿using Infragistics.Controls.Editors;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }

    public class VM : INotifyPropertyChanged
    {
        public VM()
        {
            Regions = new ObservableCollection<IdentifierDetail>()
                    {
                        new IdentifierDetail(){ Id = "0", Name = "name0"},
                        new IdentifierDetail(){ Id = "1", Name = "name1"},
                        new IdentifierDetail(){ Id = "2", Name = "name2"},
                    };
            SelectedRegions = new ObservableCollection<object>();
        }

        private ObservableCollection<IdentifierDetail> regions;

        public ObservableCollection<IdentifierDetail> Regions
        {
            get { return regions; }
            set 
            { 
                regions = value;
            }
        }


        private ObservableCollection<object> _selectedRegions;

        public ObservableCollection<object> SelectedRegions
        {

            get { return _selectedRegions; }

            set
            {
                if (_selectedRegions == null)
                _selectedRegions = value;
                OnPropertyChanged("SelectedRegions");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

    public class IdentifierDetail
    {
        private string idField;
        private string nameField;

        public string Id
        {
            get
            {
                return this.idField;
            }
            set
            {
                this.idField = value;
            }
        }

        public string Name
        {
            get
            {
                return this.nameField;
            }
            set
            {
                this.nameField = value;
            }
        }

        public override string ToString()
        {
            if (!string.IsNullOrEmpty(Name))
                return Name;
            return string.Empty;
        }

        public override int GetHashCode()
        {
            return ToString().GetHashCode();
        }

        public override bool Equals(object obj)
        {
            IdentifierDetail other = (obj as IdentifierDetail);
            if (other != null && other.Id != null && other.Name != null)
            {
                return Id.Equals(other.Id) && Name.Equals(other.Name);
            }
            return false;
        }
    }

}
